﻿namespace ArraysProj.Samples.MyModule
{
    public static class Program
    {
        public static void Main()
        {
            // Creating books array
            ArraysProj.MyModule.Books myBooks = new ArraysProj.MyModule.Books();

            // Creating and adding two array elements in two different ways  
            // 1 
            ArraysProj.MyModule.Book hp = new ArraysProj.MyModule.Book();
            hp.Title = "Harry Potter";
            hp.Pages = 870;
            myBooks.Add(hp);

            // 2 
            myBooks.Add(new ArraysProj.MyModule.Book() { Title = "Animal Farm", Pages = 102 });

            // Creating and populating the top level object (Shelf)
            ArraysProj.MyModule.Shelf myShelf = new ArraysProj.MyModule.Shelf();
            myShelf.Witdh = 120;
            myShelf.Items.SetValue(myBooks);

            // Using the generic List properties to loop through the array
            for (int i = 0; i < myShelf.Items.Count; i++) // Using Count
                System.Console.WriteLine(myShelf.Items[i]); // Using index to access Items

            // Encoding/decoding/printing 
            OSS.Asn1rt.IEncoder encoder = ArraysProjFactory.CreateEncoder();

            encoder.Encode(myShelf);
            System.Console.WriteLine(OSS.Asn1rt.Util.ByteArray.ByteArrayToHexString(encoder.Data, " ", 32));
            // output
            // 30 2b 80 01 78 a1 26 30 12 80 0c 48 61 72 72 79 20 50 6f 74 74 65 72 81 02 03 66 30 10 80 0b 41
            // 6e 69 6d 61 6c 20 46 61 72 6d 81 01 66

            OSS.Asn1rt.IDecoder decoder = ArraysProjFactory.CreateDecoder();
            decoder.Decode(encoder.Data, myShelf);
            System.Console.WriteLine(myShelf);
            // output
            // value Shelf ::=
            // {
            //   width 120,
            //   items
            //   {
            //     {
            //       title "Harry Potter",
            //       pages 870
            //     },
            //     {
            //       title "Animal Farm",
            //       pages 102
            //     }
            //   }
            // }
        }
    }
}
