namespace ArraysProj.Samples.MyModule
{
    public static class Program
    {
        public static void Main()
        {
            // Creating the array object (SEQUENCE OF Book) 
            // it is based on System.Collections.Generic.List<Book>
            var books = new ArraysProj.MyModule.Books();

            // Creating and adding array elements
            // 1 
            var hp = new ArraysProj.MyModule.Book();
            hp.Title = "Harry Potter";
            hp.Pages = 870;
            books.Add(hp);

            // 2 
            books.Add(new ArraysProj.MyModule.Book() { Title = "Animal Farm", Pages = 102 });

            // Creating and populating the top level object 
            var myShelf = new ArraysProj.MyModule.Shelf();
            myShelf.Witdh = 120;
            myShelf.Items = books;

            // Looping through Books in two different ways:
            // A - as an array by using List index and Count property
            for (int i = 0; i < myShelf.Items.Count; i++)  
                System.Console.WriteLine(myShelf.Items[i]);
            // B - as a collection by using enumeration
            foreach (var item in myShelf.Items) 
                System.Console.WriteLine(item);

            // encoding/decoding/printing
            var codec = new ArraysProj.BerCodec();

            byte[] ber = codec.Encode(myShelf);
            Oss.Asn1.ValueNotationFormatter.Print(ber, ber.Length, System.Console.Out);
            // output
            // 302B8001 78A12630 12800C48 61727279 20506F74 74657281 02036630 10800B41
            // 6E696D61 6C204661 726D8101 66
            
            codec.Decode(ber, myShelf);
            Oss.Asn1.ValueNotationFormatter.Print(myShelf, System.Console.Out);
            // output
            // value Shelf ::=
            // {
            //   width 120,
            //   items
            //   {
            //     {
            //       title "Harry Potter",
            //       pages 870
            //     },
            //     {
            //       title "Animal Farm",
            //       pages 102
            //     }
            //   }
            // }
        }
    }
}
